<?php
/*
 * geolocalisation.php
 * @copyright Copyright 2008 - http://www.e-imaginis.com
 * @copyright Portions Copyright 2003 osCommerce
 * @license GNU Public License V2.0
 * @version $Id: 
 * https://github.com/khoaofgod/phpfastcache
 * http://api.codehelper.io/ips/
 * until 100 000/hr
 *    [IP] => 66.36.130.119
 *    [ContinentCode] => NA
 *    [ContinentName] => North America
 *    [CountryCode2] => CA
 *    [Country] => CA
 *    [countryCode3] => CAN
 *    [CountryName] => Canada
 *    [RegionName] => Quebec
 *    [CityName] => Montreal
 *    [CityLatitude] => 45.5
 *    [CityLongitude] => -73.5833
 *    [countryLatitude] => 60
 *    [countryLongitude] => -96
 *    [LocalTimeZone] => America/Montreal
 *    [REMOTE_ADDR] => 91.121.69.147
 *    [HTTP_X_FORWARDED_FOR] => 
 *    [CallingCode] => 1
 *    [Population] => 33,487,208 (37)
 *    [AreaSqKm] => 9,984,670 (3)
 *    [GDP_USD] => 1.3 Trillion (14)
 *    [Capital] => Ottawa
 *    [Electrical] => 120 V,60 Hz Type A Type B
 *    [Languages] => English (official) 58.8%, French (official) 21.6%, other 19.6% (2006 Census)
 *    [Currency] => Canadian Dollar (CAD)
 *    [Flag] => http://api.easyjquery.com/proips/flags/CA.jpg
 *   echo $json['cityName'];
 * until 100 000 request by day
*/

/*
 * indicate different informations on the customer
 * @param $localisation_array return an array on the localisation
 * @access public
*/ 
  function tep_locate_customer($localisation_array) {

    if (CONFIGURATION_CURRENCIES_GEOLOCALISATION == 'true') {


// Required Libraries
      require_once(DIR_WS_CLASSES . 'ip.codehelper.io.php');
      require_once(DIR_WS_CLASSES . 'php_fast_cache.php');

// New Class
      $_ip = new ip_codehelper();

// Detect Real IP Address & Location
      $real_client_ip_address = $_ip->getRealIP();
      $json       = $_ip->getLocation($real_client_ip_address);

//      $localisation_array = array();
      $localisation_array = array('continent_code' => $json['ContinentCode'],
                                  'country_code2' =>  $json['CountryCode2']
                                 ); 
    }

    return $localisation_array;
  }


/*
 * Currency in function the localisation
 * @param $new_currency return the currency in function the localisation
 * @access public
*/ 
  function tep_get_currencies_location($new_currency) {

    $localisation = tep_locate_customer($localisation_array);
    $continent_code = $localisation['continent_code'];
    $country_code2 = $localisation['country_code2'];

// north america and south america
    if ($continent_code == 'NA') {
      if ($country_code2 == 'CA') {
        if (DEFAULT_CURRENCY != 'CAD') {
          $new_currency = 'CAD';
        } else { 
          $new_currency = DEFAULT_CURRENCY; 
        }
      } elseif ($country_code2 == 'US') {
        if (DEFAULT_CURRENCY != 'USD') {
          $new_currency = 'USD';
        } else { 
          $new_currency = DEFAULT_CURRENCY; 
        }
      } else {
        $new_currency = DEFAULT_CURRENCY;   
      }
    } elseif ($continent_code == 'EU') {
      if (DEFAULT_CURRENCY != 'EUR') {
        $new_currency = 'EUR';
      } else { 
        $new_currency = DEFAULT_CURRENCY; 
      }
    } else {
      $new_currency = DEFAULT_CURRENCY;   
    }  

   return $new_currency;
  } // end tep_currencies_localtion

/*
 * Count the number of files inside a directory
 * @param 
 * @return string  $number_of_files, number of the files inside directory
 * @access public
*/ 
  function tep_count_files_directory_cache_geolocalisation () {
    if (dir(DIR_FS_CACHE .'geolocalisation/') ) {
      $count_files_directory = DIR_FS_CACHE .'geolocalisation/';
    } else {
      $count_files_directory = DIR_FS_CATALOG . 'cache/geolocalisation/';  
    }

    $scandir = scandir($count_files_directory);
    $number_of_files = count($scandir) - 2;

    return  $number_of_files;
  }

/*
 * delete all the files inside a directory if there more 100 files
 * @param 
 * @return
 * @access public
*/ 
  function tep_delete_files_directory_cache_geolocalisation() {

    if (dir(DIR_FS_CACHE .'geolocalisation/') ) {
      $count_files_directory = DIR_FS_CACHE .'geolocalisation/';
    } else {
      $count_files_directory = DIR_FS_CATALOG . 'cache/geolocalisation/';  
    }

    $number_files = tep_count_files_directory_cache_geolocalisation ();

    if ($number_files > 100) {
      $handle=opendir($directory); 
      while (false !== ($fichier = readdir($handle))) { 
        if (($fichier != ".") && ($fichier != "..")) { 
          unlink($directory.$fichier); 
        } 
      } 
    }

    return;
  }

?>
